#include<stdlib.h>
#include<stdio.h>
#include"test2.h"
#include "libtcc.h"


TCCState *s;
void *mem[2];
int size;

typedef int (*PointyFunc)();
PointyFunc func[2];

PointyFunc compile(char CFile[], char FSymbol[], int n) {
	s = tcc_new();
	if (!s) {
		fprintf(stderr, "Could not create tcc state \n");
		exit(1);
	}
	tcc_set_output_type(s, TCC_OUTPUT_MEMORY);
	tcc_add_include_path(s, "/usr/include");
	tcc_add_sysinclude_path(s, "/usr/include/sys");
	if (tcc_compile_string(s, CFile) == -1) {
		fprintf(stderr, "Failure compiling (CFile[]):\n %s", CFile);
		exit(1);
	}
//	  tcc_add_symbol(s, "add", add);
	size = tcc_relocate(s, NULL);
	if (size == -1) {
		exit(1);
	}
	mem[n] = malloc(size);
	tcc_relocate(s, mem[n]);
	free(CFile);
	int (*FPointer)() = tcc_get_symbol(s,FSymbol);
	return FPointer;
};

int main (int argc, char *argv[]) {
	func[0] = compile(load_CFile("test2.c"),"load_CFile",0);
	if (!func[0]) {
		exit(1);
	}
	printf("%s \n", func[0]("test2.c"));
	tcc_delete(s);
	func[1] = compile(load_CFile("test2.c"),"load_CFile",1);
	if (!func[1]) {
		exit(1);
	}
	printf("%p \n", *func[1]);
	printf("%s \n", func[1]("test.c"));
	tcc_delete(s);

	free(mem[0]);
	free(mem[1]);
	return 0;
}

